#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdarg.h>
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_ttf.h>
#include <resources.h>
#include <scene.h>
#include <errno.h>

#define MAX_OBJS     64

static SDL_Surface * output;
static struct scene_object * objects[MAX_OBJS];

int scene_objadd(struct scene_object * obj)
{
 int i;
 for(i=0;i<MAX_OBJS;i++)
 {
  if(!objects[i])
  {
   objects[i] = obj;
   return 0;
  }
 }
 return -1;
}

int scene_objdel(char * name)
{
 int i;
 for(i=0;i<MAX_OBJS;i++)
 {
  if (!objects[i]) continue;
  if (!strcmp(objects[i]->name, name))
  {
   objects[i] = NULL;
   return 0;
  }
 }
 return -1;
}

struct scene_object * scene_objget(char * name)
{
 int i;
 for(i=0;i<MAX_OBJS;i++)
 {
  if (!objects[i]) continue;
  if (!strcmp(objects[i]->name, name))
  {
   return objects[i];
  }
 }
 return NULL;
}

void scene_render(void)
{
 SDL_Rect offset; 
 int i;
 // Rysujemy obiekty
 for(i=0;i<MAX_OBJS;i++)
 {
  if (!objects[i]) continue;
  offset.x = objects[i]->x;
  offset.y = objects[i]->y;
  offset.w = objects[i]->w;
  offset.h = objects[i]->h;
  SDL_BlitSurface(objects[i]->image, NULL, output, &offset);
 }
 // Pokaz odrysowana klatke
 SDL_Flip(output);
}

int scene_init(SDL_Surface * screen)
{
 output = screen;
}

void scene_cleanup(void)
{
 
}
